(*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: SKA (Skarbonki)                                *
 *   Plik:                ska.pas                                        *
 *   Autor:               Pawe Wolff                                    *
 *   Opis:                Rozwizanie wzorcowe zadania SKARBONKI         *
 *                                                                       *
 *************************************************************************)

program Skarbonki;


const
  MAX_N = 1000000;


var
  n: longint;
  klucz: array [1..MAX_N] of longint;
    { klucz[i] = numer skarbonki, w ktrej znajduje si i-ty klucz;
      tablica ta definiuje graf skierowany: wierzchokami s klucze
      o numerach 1, 2, ..., n, a krawdzie prowadz od wierzchoka 
      o numerze i do wierzchoka o numerze klucz[i] (dla wszystkich
      i = 1, 2, ..., n); zatem jest to graf, w ktrym stopie wyjciowy
      kadego wierzchoka jest rwny 1 }

  numer: array [1..MAX_N] of longint;
    { ta tablica bdzie potrzebna w funkcji IleCykli;
      numer[j] = 0: j-ty wierzchoek jest "nieodwiedzony"
      numer[j] = i: j-ty wierzchoek zosta "odwiedzony z wierzchoka i" }


procedure WczytajDane;
var
  i: longint;

begin
  Readln(n);
  
  for i := 1 to n do
    Readln(klucz[i]);
end;


function IleCykli: longint;
{ Liczymy liczb cykli w grafie zdefiniowanym przez tablic klucz.
  Dziki temu, e stopie wyjciowy kadego wierzchoka grafu wynosi 1,
  moemy to zrobi w nastpujcy sposb.
  Pocztkowo wszystkie wierzchoki oznaczamy jako "nieodwiedzone".
  Nastpnie z kadego wierzchoka (powiedzmy o numerze i) odwiedzamy
  "nieodwiedzone" od tej pory wierzchoki (z kadego kolejnego wychodzc
  jedyn krawdzi), zaznaczajc, e zostay "odwiedzone z wierzchoka i".
  Jeeli napotkamy wierzchoek, ktry zosta ju
  "odwiedzony z wierzchoka j", to znaczy, e:
  - znalelimy nowy cykl, o ile i = j,
  - w przeciwnym razie dotarlimy do wierzchoka, ktry znajduje si
    na cyklu ju wczeniej znalezionym bad te z ktrego wczeniej
    dotarlimy do takowego cyklu. }
var
  i, j, lCykli: longint;

begin
  lCykli := 0;

  for i := 1 to n do
    numer[i] := 0;

  for i := 1 to n do begin
    j := i;
    while numer[j] = 0 do begin
      numer[j] := i;
      j := klucz[j];
    end;
    
    if numer[j] = i then
      Inc(lCykli);
  end;

  IleCykli := lCykli;
end;



begin
  WczytajDane;
  Writeln(IleCykli);
end.
