(*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: SKA (Skarbonki)                                *
 *   Plik:                skab2.pas                                      *
 *   Autor:               Pawe Wolff                                    *
 *   Opis:                Rozwizanie niepoprawne zadania SKARBONKI      *
 *                                                                       *
 *************************************************************************)

program Skarbonki_b2;


const
  MAX_N = 1000000;


var
  n: longint;
  klucz: array [1..MAX_N] of longint;
    { klucz[i] = numer skarbonki, w ktrej znajduje si i-ty klucz;
      tablica ta definiuje graf skierowany: wierzchokami s klucze
      o numerach 1, 2, ..., n, a krawdzie prowadz od wierzchoka 
      o numerze i do wierzchoka o numerze klucz[i] (dla wszystkich
      i = 1, 2, ..., n); zatem jest to graf, w ktrym stopie wyjciowy
      kadego wierzchoka jest rwny 1 }


procedure WczytajDane;
var
  i: longint;

begin
  Readln(n);
  
  for i := 1 to n do
    Readln(klucz[i]);
end;


function IleCykli: longint;
{ Liczymy liczb cykli w grafie zdefiniowanym przez tablic klucz.
  Moemy to zrobi (niepoprawnie) w nastpujcy sposb.
  Bdziemy odwiedza wierzchoki grafu, poruszajc si wzdu krawdzi.
  Po przejciu dan krawdzi, bdziemy j usuwa.
  (Zauwamy zatem, e w kadym momencie dziaania algorytmu stopie
  wyjciowy kadego wierzchoka wynosi 0 lub 1.)
  Z kadego wierzchoka (powiedzmy o numerze i), z ktrego wychodzi
  krawd, rozpoczynamy odwiedzanie nastpnych wierzchokw
  (poruszajc si wzdu krawdzi i przy tym usuwajc je).
  Takie odwiedzanie koczy si, gdy znajdziemy si w wierzchoku, z ktrego
  nie wychodzi adna krawd. 
  Wwczas, jeli numer tego wierzchoka
  - jest rwny i, to znaczy, e znalelimy nowy cykl,
  - jest rny od i, to znaczy, e dotarlimy do wierzchoka, ktry
    znajduje si na cyklu ju wczeniej znalezionym bad te z ktrego
    wczeniej dotarlimy do takowego cyklu. }
var
  i, j, pom, lCykli: longint;

begin
  lCykli := 0;

  for i := 1 to n do
    if klucz[i] <> 0 then begin
      j := i;
      repeat
        pom := klucz[j];
        klucz[j] := 0;
        j := pom;
      until klucz[j] = 0;
      
      if j = i then
        Inc(lCykli);
    end;

  IleCykli := lCykli;
end;


begin
  WczytajDane;
  Writeln(IleCykli);
end.
