/*************************************************************************
 *                                                                       *
 *                    XII Olimpiada Informatyczna                        *
 *                                                                       *
 *   Rozwizanie zadania: SZA (Szablon)                                  *
 *   Plik:                sza3.cpp                                       *
 *   Autor:               Jakub Radoszewski                              *
 *   Opis:                Rozwiazanie nadoptymalne                       *
 *                        Program o zoonoci czasowej                  *
 *                        i pamiciowej O(n), obliczajcy dugoci       *
 *                        szablonw on-line.                             *
 *                                                                       *
 *************************************************************************/

#include<cstdio>
#include<string>
using namespace std;

#define MAX_LEN 500000

/* Deklaracje zmiennych globalnych. */
int pref_suf[MAX_LEN + 1];      // Tablica dugoci najduszych prefikso-sufiksw
                           // (tak zwana funkcja prefiksowa).
char sl[MAX_LEN];               // Rozwaane sowo.
int n;                          // Dugo rozwaanego sowa.

int zakres[MAX_LEN + 1],        // Zakresy sowa, ktre mona pokry poszczeglnymi
                           // prefiksami sowa, jako szablonami.
 szablony[MAX_LEN + 1];         // Najkrtsze szablony dla kolejnych
                           // prefiksw sowa.


/* Procedura wyliczajca wartoci funkcji prefiksowej
 * dla podanego w parametrze sowa.
 * Zakadamy przy tym dla uatwienia, e
 * litery sowa s numerowane od jedynki (czyli litera
 * zerowa sowa jest nieznaczca). */
void licz_pref_suf(string slowo)
{
  int k = 0;

  /* Inicjalizacja funkcji prefiksowej. */
  pref_suf[0] = pref_suf[1] = 0;

  /* Wyliczanie kolejnych wartoci funkcji prefiksowej. */
  for (int q = 2; q <= n; q++) {
    /* Niezmiennik: najduszy prefikso-sufiks prefiksu danego
       sowa o dugoci q ma dugo k. */
    while (k > 0 && slowo[k + 1] != slowo[q])
      k = pref_suf[k];
    if (slowo[k + 1] == slowo[q])
      k++;
    pref_suf[q] = k;
  }                             /* for */
}                               /* licz_pref_suf */


int main()
{
  /* Odczyt sowa i wyliczenie funkcji prefiksowej. */
  scanf("%s", sl);
  n = strlen(sl);
  licz_pref_suf('a' + string(sl));

  /* Obliczanie najkrtszych szablonw dla prefiksw sowa,
     wykonywane on-line. */
  for (int j = 1; j <= n; j++)
    szablony[j] = zakres[j] = j;

  /* Ptla po wszystkich, duszych ni jeden, prefiksach
     danego sowa - w j-tym kroku rozwaamy j-ty prefiks. */
  for (int j = 2; j <= n; j++) {
    int b = pref_suf[j];
    if (b > 0) {
      /* Sprawdzamy, czy najkrtszy szablon najduszego prefikso-sufiksu
         danego prefiksu sowa jest dobrym szablonem dla aktualnego
         prefiksu: */
      int q = szablony[b];
      if (zakres[q] >= j - q) {
        /* jeeli tak, to wybieramy jego jako szablon, */
        szablony[j] = q;
        zakres[q] = j;
      }                         /* if */
      /* jeeli nie, to ju jest ustawione szablony[i]=i. */
    }                           /* if */
  }                             /* for */

  /* Wypisanie wyniku */
  printf("%d\n", szablony[n]);
  return 0;
}                               /* main */
